C     Last change:  SC    2 Mar 2004    4:07 pm
      PROGRAM RESAN22k
C       NON-LINEARITY AND RESIDUALS ANALYSIS PROGRAM BY R. L. COOLEY, USGS, 
C          DENVER, COLO.
C       MODIFIED FOR MODFLOW-2000 BY STEEN CHRISTENSEN, DEPT. OF AARHUS, DENMARK.
C          NOT ADAPTED FOR DRY OBSERVATIONS
C       THE INPUT AND PREPARATION PART AND SOME OUTPUT SUBROUTINES ARE
C          MODIFICATIONS FROM RESAN2K BY E.R. BANTA, 8/12/1999
C
C     ******************************************************************
C     X(NPAR,NOBS):    sensitivity matrix AND THE SENSITIVITY MATRIX
C                      TIMES THE SQUARE ROOT OF THE WEIGHT MATRIX. FOR
C                      THE LATTER THE SECOND DIMENSION IS NOBS+MPR+IPR.
C     W(NH):           SQUARE-ROOT OF WEIGHT MATRIX FOR HEADS
C     WQ(NQT,NQT):     SQUARE-ROOT OF WEIGHT MATRIX FOR FLOWS
C     COV(NPAR,NPAR):  PARAMETER COVARIANCE MATRIX
C     E(NTOT):         WEIGHTED RESIDUALS
C     F(NTOT):         cumulative probability
C     VAR:             s^2
C     R(I) = (I-R)*VAR
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*40 VERSION
      PARAMETER (VERSION='1.0.0 25/06/2003')
      CHARACTER*4 BLANK
      CHARACTER*12 TMPDID
      CHARACTER*80 OUTNAM
      CHARACTER*84 FN
      DIMENSION AM(55)
      DOUBLE PRECISION COV,VAR,BUFF1,BUFF3
      CHARACTER*10, ALLOCATABLE :: PARNAM(:)
      CHARACTER*12, ALLOCATABLE :: DID(:), DID1(:)
      ALLOCATABLE :: X(:,:), X0(:,:), COV(:,:), W(:), 
     &         ET(:), R(:,:), D(:), E(:), U(:), 
     &         V(:,:), F(:), WQ(:,:), WP(:), CE(:), 
     &         BUFF2(:), NIPR(:), WTPS(:,:), PRM(:,:), 
     &         DM(:),  DV(:), FRQ(:), BUFF1(:,:), 
     &         BUFF3(:), ISYM(:), ISYM1(:)
C     
      COMMON/ITP/IIN,IOUT
C     ------------------------------------------------------------------
 1010 FORMAT (7I5,I10,F25.0,F10.0,4I5)
 1020 FORMAT (8F15.0)
 1030 FORMAT (//,
     &        ' NUMBER OF ESTIMATED PARAMETERS.............. ',I6,/,
     &        ' NUMBER OF OBSERVATIONS ..................... ',I6,/,
     &        ' NUMBER OF HEADS ............................ ',I6,/,
     &        ' NUMBER OF OBSERVATIONS OTHER THAN HEADS .... ',I6,/,
     &        ' NUMBER OF PRIOR EQUATIONS................... ',I6,/,
     &        ' NUMBER OF PRIOR WITH FULL WEIGHT MATRIX..... ',I6,/,
     &        ' NUMBER OF SETS OF RANDOM DEVIATES .......... ',I6,/,
     &        ' NUMBER FOR RANDOM NUMBER GENERATOR ......... ',I11,/,
     &        ' CALCULATED ERROR VARIANCE .................. ',G13.6,/,
     &        ' THEORETICAL ERROR VARIANCE ................. ',G13.6,/,
     &        ' PRINT (I-R) MATRIX.......................... ',I6,/,
     &        ' PRINT SIMULATED RESIDUALS................... ',I6,/,
     &        ' READ MEAN TRUE ERRORS....................... ',I6,/,
     &        ' READ OBSERVATION ERROR COVARIANCE MATRIX.... ',I6,/)
 1040 FORMAT (/,14X,'RELIABILITY WEIGHTS FOR SAMPLE INFORMATION',/,
     &2X,2(6X,'OBSERVATION',15X),/,
     &2X,2('OBS#',5X,'NAME',7X,'W**.5',7X))
 1050 FORMAT (/'MEAN WEIGHTED RESIDUAL (EM) --------- = ',G11.5
     $/'SLOPE OF WEIGHTED RESIDUAL PLOT (SLP) = ',G11.5
     $/'INTRINSIC NONLINEARITY MEASURE (QINT) = ',G11.5,
     & ' (SHOULD BE <<',G11.5,')')
 1060 FORMAT (/,' COVARIANCE MATRIX FOR ESTIMATED PARAMETERS')
 1070 FORMAT (/,1X,'SENSITIVITIES FOR OPTIMUM PARAMETERS')
 1075 FORMAT (/,9X,'ORDERED, WEIGHTED RESIDUALS',/,
     &10X,'OBSERVATION',/
     &4X,'NO.',6X,'NAME',12X,'E',9X,'FRQ. (%)')
 1110 FORMAT (/,1X,'DATA GENERATED FROM RANDOM NUMBER SET NO. ',I3)
 1138 FORMAT (/,20X,'SIMULATED WEIGHTED RESIDUALS',/,
     &2X,2(6X,'OBSERVATION',15X),/
     &2X,2(1X,'NO.',5X,'NAME',10X,'G',8X))
 1140 FORMAT (/,9X,'ORDERED, SIMULATED WEIGHTED RESIDUALS',/,
     &10X,'OBSERVATION',/
     &4X,'NO.',6X,'NAME',12X,'D',9X,'FRQ. (%)')
 1142 FORMAT (/,9X,'MEAN ORDERED, SIMULATED WEIGHTED RESIDUALS',/,
     &10X,'OBSERVATION',/
     &4X,'NO.',6X,'NAME',12X,'D',9X,'FRQ. (%)')
 1144 FORMAT (/,9X,'STD. DVS. OF ORDERED, SIMULATED WEIGHTED RESIDUALS',
     &/,10X,'OBSERVATION',/
     &4X,'NO.',6X,'NAME',12X,'D',9X,'FRQ. (%)')
 1146 FORMAT (/'CORRELATION (CED) --------------- = ',G11.5
     $/'PROBABILITY OF CORRELATION (PROB) = ',G11.5
     $/'99% CONFIDENCE LIMIT (CL99) ----- = ',G11.5
     $/'95% CONFIDENCE LIMIT (CL95) ----- = ',G11.5
     $/'90% CONFIDENCE LIMIT (CL90) ----- = ',G11.5)
 1148 FORMAT (/23X,'IDENTITY MINUS HAT MATRIX'/,
     $3X,'OBSERVATION NAME',15X,'I-R')   
 1150 FORMAT(' ERROR OPENING FILE "',A,'" -- STOP EXECUTION')
 1160 FORMAT (36X,'RESAN2-2k',//,
     &22X,'MODFLOW-2000 POST-PROCESSING PROGRAM',/,
     &15X,'TO PERFORM ANALYSIS OF NON-LINEARITY AND RESIDUALS',/,
     &28X,'Version ',A/)
 1170 FORMAT(
     &' ERROR FINDING INPUT FILES.  OUTNAM MUST BE SPECIFIED AS A',/,
     &' STRING OTHER THAN "NONE" IN THE OBS FILE.  THE FILE',/,
     &' RESAN.ERR MAY CONTAIN ADDITIONAL DIAGNOSTIC INFORMATION')
 1180 FORMAT(16F25.0)
 1185 FORMAT(16F15.0)
 1230 FORMAT(1X,'WEIGHTED RESIDUALS WILL BE READ FROM FILE ',A)
 1250 FORMAT (2(G15.7,1X),I5,2X,A)
 1350 FORMAT(6(A10,1X))
 1410 FORMAT(/,1X,'*** ERROR: ',A,/,1X,'EXCEEDS ARRAY LIMIT OF ',
     &       I8,/,1X,'INCREASE ',A,' AND RECOMPILE PROGRAM')
 1420 FORMAT(16I5)
 1470 FORMAT(2X,'"ORD.WEIGHT.RES."',
     &       2X,'"ORD.SIM.WT.RES."',
     &       2X,'"STDVS.O.S.W.RS."',
     &       2X,'"2*STDV.O.S.W.R."',
     &       2X,'"FREQUENCY/PROB."',
     &       2X,'"PROB.PLOT.POSI."',
     &       2X,'"OBSERVATION"',
     &       3X,'"PLOT-SYMBOL"')
 1480 FORMAT(6(4X,G15.5),2X,A12,2X,I6)
C
C     WRITE PROGRAM NAME AND VERSION TO SCREEN
      WRITE (*,*)
      WRITE (*,1160) VERSION
C ***
C**DEFINE AND OPEN INPUT FILES AND OUTPUT FILE, AND DIMENSION ARRAYS
C   FOR SUBROUTINE PRTOT
      IIN=1
      IOUT=2
      IPLOTD=3
      INWR=8
      ISCR=11
      OPEN(ISCR,STATUS='SCRATCH',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      OPEN(IOUT,FILE='RESAN.ERR',STATUS='UNKNOWN',
     &     ACCESS='SEQUENTIAL',FORM='FORMATTED')
C     FIND INPUT FILE BY READING NAME AND OBS FILES, AND READING OUTNAM
      CALL FINDINP(IOUT,OUTNAM,INWR)
      IF (OUTNAM.EQ.'NONE') THEN
        WRITE(*,1170)
        CLOSE(IOUT)
        STOP
      ELSE
        CLOSE(IOUT,STATUS='DELETE')
      ENDIF
      LENGNAM = NONB_LEN(OUTNAM,80)
      FN = OUTNAM(1:LENGNAM)//'.#nr'
      OPEN (IOUT,FILE=FN,STATUS='UNKNOWN')
      WRITE (IOUT,1160) VERSION
C  OPEN FILE FOR NORMAL PROBABILITY GRAPH OF RANDOM NUMBERS
      FN = OUTNAM(1:LENGNAM)//'._md'
      OPEN(IPLOTD,FILE=FN,STATUS='UNKNOWN',
     &     ACCESS='SEQUENTIAL',FORM='FORMATTED')
      BLANK='    '
C**READ AND PRINT INPUT DATA FROM THE _RS FILE AND CONVERT IT AS NEEDED
C  FOR CALCULATIONS
C**NOTE: NRAN MUST BE ODD AND MUST LIE BETWEEN 1 AND 1048575
      FN = OUTNAM(1:LENGNAM)//'._ws'
      OPEN (INWR,FILE=FN,STATUS='OLD',ACCESS='SEQUENTIAL',
     &      FORM='FORMATTED',ERR=10,IOSTAT=IOS)
   10 CONTINUE
      IF (IOS.NE.0) THEN
        LENGNAM = NONB_LEN(FN,84)
        WRITE (*,1150) FN(1:LENGNAM)
        STOP
      ENDIF
      WRITE(IOUT,1230) FN(1:LENGNAM+4)
C
      FN = OUTNAM(1:LENGNAM)//'._rs'
      OPEN (IIN,FILE=FN,STATUS='OLD',ACCESS='SEQUENTIAL',
     &      FORM='FORMATTED',ERR=20,IOSTAT=IOS)
   20 CONTINUE
      IF (IOS.NE.0) THEN
        LENGNAM = NONB_LEN(FN,84)
        WRITE (*,1150) FN(1:LENGNAM)
        STOP
      ENDIF
C     READ ITEM 1 OF _rs FILE
      READ(IIN,1010) NPAR,NOBS,NH,NQT,MPR,IPR,NSETS,NRAN,VAR,STDV,IPCF,
     $               IPRN,IERT,ICOV
      IF (NRAN.GT.0) NRAN=-NRAN
      WRITE(IOUT,1030) NPAR,NOBS,NH,NQT,MPR,IPR,NSETS,NRAN,VAR,STDV,
     $                 IPCF,IPRN,IERT,ICOV
      STDV=SQRT(STDV)
      IF (NOBS.NE.NH+NQT) THEN
         WRITE(IOUT,*) ' ERROR: NOBS NOT EQUAL TO NH+NQT'
         STOP ' ERROR: NOBS NOT EQUAL TO NH+NQT'
      ENDIF
      NTOT = NOBS+MPR+IPR
C
C     ALLOCATE ARRAY MEMORY
C     
      ALLOCATE(X(NPAR,NTOT), X0(NPAR,NQT), COV(NPAR,NPAR), W(NH), 
     &         ET(NOBS), R(NTOT,NTOT), D(NTOT), E(NTOT), U(NTOT), 
     &         V(NOBS,NOBS), F(NTOT), WQ(NQT,NQT), WP(MPR), CE(NSETS), 
     &         BUFF2(NTOT), NIPR(IPR), WTPS(IPR,IPR), PRM(NPAR,MPR), 
     &         DM(NTOT),  DV(NTOT), FRQ(NTOT), BUFF1(NOBS,NOBS), 
     &         BUFF3(NOBS), ISYM(NTOT), PARNAM(NPAR), DID(NTOT), 
     &         DID1(NTOT), ISYM1(NTOT))
      NP=NPAR
      NOB=NOBS
      NQ=NQT
      NALL=NTOT
C
C *** READ WEIGHTED RESIDUALS AND WEIGHTED SIMULATED VALUES FROM THE _WS
C     FILE TO DEFINE THE DATA PLOT SYMBOLS AND OBS-NAME AND AS NEEDED TO
C     COMPUTE NON-LINEARITY MEASURES
      DO 30 I=1,NTOT
        READ(INWR,1250) F(I),E(I),ISYM(I),DID(I)
        DID1(I) = DID(I)
        ISYM1(I) = ISYM(I)
   30 CONTINUE
      READ(IIN,1350) (PARNAM(I),I=1,NPAR)
C     READ AND WRITE VARIANCE-COVARIANCE MATRIX ON THE PARAMETERS
      DO 50 J=1,NPAR
        READ(IIN,1180) (COV(I,J),I=J,NPAR)
        DO 40 I=J,NPAR
   40   COV(J,I)=COV(I,J)
   50 CONTINUE
      WRITE(IOUT,1060)
      CALL UPARPM(COV,NPAR,8,IOUT,PARNAM,NP)
C     OBSERVATIONS WITH A DIAGONAL WEIGHT MATRIX
C         THE SQUARE-ROOT OF THE WEIGHT IS READ
      IF (NH.GT.0) READ(IIN,1185) (W(I),I=1,NH)
      WRITE(IOUT,1040)
      CALL PRTOTA(DID,W,NH)
C    OBSERVATIONS WITH A FULL WEIGHT MATRIX
C         THE SQUARE-ROOT OF THE WEIGHT MATRIX IS READ
      IF (NQT.GT.0) THEN
        DO 60 I = 1, NQT
          READ (IIN,1185) (WQ(I,J),J=1,NQT)
   60   CONTINUE
        WRITE (IOUT,*) ' '
        WRITE (IOUT,*) ' OBSERVATIONS WITH A FULL WEIGHT MATRIX:'
        CALL PRTOT(WQ,NQT,NQT,NQ)
      ENDIF
C     READ AND WRITE SENSITIVITIES
      DO 70 J=1,NOBS
        READ(IIN,1185) (X(I,J),I=1,NPAR)
   70 CONTINUE
      WRITE(IOUT,1070)
      CALL PRTOTX(X,NPAR,NOBS,NP,DID,PARNAM)
C     INITIALIZE ARRAY ELEMENTS THAT WILL HOLD SENSITIVITIES FOR PRIOR
C     INFORMATION
      IF(MPR+IPR.GT.0) THEN
        DO 90 I=1,MPR+IPR
          DO 80 J=1,NPAR
            X(J,NOBS+I)=0.D0
   80     CONTINUE
   90   CONTINUE
      ENDIF
C     PRIOR INFORMATION FROM EQUATIONS
      IF (MPR.GT.0) THEN
        DO 100 IPM=1,MPR
          READ(IIN,1020) (PRM(J,IPM),J=1,NPAR),WP(IPM)
  100   CONTINUE
      ENDIF
C     PRIOR INFORMATION WITH FULL WEIGHT MATRIX
      IF (IPR.GT.0) THEN
        READ(IIN,1420) (NIPR(I),I=1,IPR)
        DO 110 I=1,IPR
          READ(IIN,1020) (WTPS(I,J),J=1,IPR)
  110   CONTINUE
      ENDIF
C     MEAN TRUE ERRORS
      IF (IERT.GT.0) THEN
         READ(IIN,*) (ET(I),I=1,NOBS)
      END IF
C     READ OBSERVATION COVARIANCE MATRIX, V, AND CONVERT TO V**.5
      IF (ICOV.GT.0) THEN
         READ(IIN,*) ((V(I,J),J=1,NOBS),I=1,NOBS)
         CALL SVD(NOBS,V,BUFF1,BUFF3,NOB)
      END IF
C
C     CALCULATE W**.5 X, W**.5 ET, W**.5 V
C        OBSERVATIONS WITH A DIAGONAL WEIGHT MATRIX
      IF (NH.GT.0) THEN
         DO 130 J=1,NH
            WT=W(J)
            DO 120 I=1,NPAR
               X(I,J)=X(I,J)*WT
  120       CONTINUE
            IF (IERT.GT.0) ET(J)=ET(J)*WT
            IF (ICOV.GT.0) THEN
               DO 125 I=1,NH
                  V(I,J)=V(I,J)*WT
  125          CONTINUE
            END IF
  130    CONTINUE
      END IF   
C        OBSERVATIONS WITH FULL WEIGHT MATRIX
      IF (NQT.GT.0) THEN
         DO 140 I=1,NPAR
            DO 138 K=1,NQT
               XT = 0.D0
               DO 135 L=1,NQT
                  XT = XT + WQ(K,L) * X(I,NH+L)
  135          CONTINUE
               X0(I,K) = XT
  138       CONTINUE
  140    CONTINUE
         DO 150 I=1,NPAR
           DO 145 K=1,NQT
             X(I,NH+K) = X0(I,K)
  145      CONTINUE
  150    CONTINUE
         N1=NH+1
         IF (IERT.GT.0) THEN
            DO 160 I=N1,NOBS
               SUM=0.
               DO 155 J=N1,NOBS
                  SUM=SUM+WQ(I,J)*ET(J) 
  155          CONTINUE
               BUFF2(I)=SUM
  160       CONTINUE
            DO 165 I=N1,NOBS
               ET(I)=BUFF2(I)
  165       CONTINUE
         END IF
         IF (ICOV.GT.0) THEN
            DO 180 I=N1,NOBS
               DO 175 J=N1,NOBS
                  SUM=0.
                  DO 170 K=N1,NOBS
                     SUM=SUM+V(I,K)*WQ(K,J)
  170             CONTINUE
                  BUFF1(I,J)=SUM
  175          CONTINUE
  180       CONTINUE
            DO 190 I=N1,NOBS
               DO 185 J=N1,NOBS
                  V(I,J)=BUFF1(I,J) 
  185          CONTINUE
  190       CONTINUE
         END IF
      END IF
C        PRIOR INFORMATION FROM EQUATIONS
      IF(MPR.GT.0) THEN
        DO 200 I=1,NPAR
          DO 195 L=1,MPR
            X(I,L+NOBS) = WP(L) * PRM(I,L)
  195     CONTINUE
  200   CONTINUE
      ENDIF
C        PRIOR WITH A FULL WEIGHT MATRIX
      IF (IPR.GT.0) THEN
        DO 220 I=1,IPR
          DO 210 K=1,IPR
            X(NIPR(I),I+MPR+NOBS) = WTPS(K,I)
  210     CONTINUE
  220   CONTINUE
      ENDIF
C
C**COMPUTE R MATRIX
C
      DO 235 K=1,NTOT
        DO 230 J=1,NPAR
          SUM=0.D0
          DO 225 I=1,NPAR
            SUM=SUM+X(I,K)*COV(I,J)
  225     CONTINUE
          R(J,K)=SUM
  230   CONTINUE
  235 CONTINUE
      DO 250 K=1,NTOT
        DO 245 J=K,NTOT
          SUM=0.D0
          DO 240 I=1,NPAR
            SUM=SUM+X(I,K)*R(I,J)
  240     CONTINUE
          R(J,K)=SUM/VAR
  245   CONTINUE
  250 CONTINUE
      DO 260 J=1,NTOT
        DO 255 I=J,NTOT
          R(J,I)=R(I,J)
  255   CONTINUE
  260 CONTINUE
  
C
C**COMPUTE MEAN WEIGHTED RESIDUAL (EM), SLOPE OF THE PLOT OF WEIGHTED 
C     RESIDUALS VERSUS WEIGHTED SIMULATED VALUES (SLP), AND 
C     NON-LINEARITY MEASURE (QINT)
      EM=0.0
      FS=0.0
      EF=0.0
      ES=0.0
      QINT=0.0
      DO 290 J=1,NTOT
         EM=EM+E(J)
         ES=ES+E(J)*E(J)
         FS=FS+F(J)
         EF=EF+E(J)*F(J)
         SUM=0.0
         DO 285 I=1,NTOT
            SUM=SUM+R(I,J)*E(I) 
  285    CONTINUE
         QINT=QINT+SUM**2
  290 CONTINUE
      RNT=NTOT
      EM=EM/RNT
      FM=FS/RNT
      FVR=0.0
      DO 295 I=1,NTOT
         FVR=FVR+(F(I)-FM)*(F(I)-FM)
  295 CONTINUE
      SLP=(EF-EM*FS)/FVR
      WRITE(IOUT,1050) EM,SLP,QINT,ES
C
C**COMPUTE I-R MATRIX
C
      DO 300 J=1,NTOT
        DO 297 I=1,NTOT
          R(I,J)=-R(I,J)
  297   CONTINUE
        R(J,J)=1.+R(J,J)
  300 CONTINUE
C  
C**INITIALIZE VARIABLES AND COMPUTE PLOTTING POSITIONS     
      TMP=1./NTOT
      DO 305 I=1,NTOT
         DM(I)=0.
         DV(I)=0.
         FRQ(I)=TMP*(I-.5)
         CALL UNORM(BUFF2(I),FRQ(I),-1)
         FRQ(I)=100.*FRQ(I)
  305 CONTINUE
C  
C**ORDER WEIGHTED RESIDUALS FROM SMALLEST TO LARGEST AND PRINT
C     ORDERED RESIDUALS  
      DO 320 I=1,NTOT    
         EI=E(I)
         DO 310 J=I,NTOT
            IF (E(J).LT.EI) THEN
               TMP=EI
               EI=E(J)
               E(J)=TMP
               TMPDID=DID1(I)
               DID1(I)=DID1(J)
               DID1(J)=TMPDID
               ISYMTMP=ISYM1(I)
               ISYM1(I)=ISYM1(J)
               ISYM1(J)=ISYMTMP
            ENDIF
  310    CONTINUE  
         E(I)=EI 
  320 CONTINUE
      WRITE(IOUT,1075)
      CALL PRTOTD2(DID1,E,FRQ,NTOT)
C      
C**LOOP ON MONTE CARLO GENERATION OF SIMULATED RESIDUALS
      IF(NSETS.LT.1) GO TO 530     
      IF (STDV.LE.0) STDV=ES/(NTOT-NPAR)
      ISET=0
      DO 430 IS=1,NSETS
C         COMPUTE U AS N(0,VAR) RANDOM VARIABLES
         DO 330 J=1,NTOT
            U(J)=STDV*RNDV(RNSV,AM,IK,IKP,NRAN,ISET)
  330    CONTINUE
C         MODIFY U WITH OBSERVATION COVARIANCE MATRIX AND MEAN TRUE
C         ERRORS, IF SPECIFIED
         IF (ICOV.GT.0) THEN
            DO 334 I=1,NOBS
               SUM=0.
               DO 333 J=1,NOBS
                  SUM=SUM+V(I,J)*U(J) 
  333          CONTINUE
               BUFF3(I)=SUM
  334       CONTINUE
            DO 335 I=1,NOBS
               U(I)=BUFF3(I)
  335       CONTINUE
         END IF   
         IF (IERT.GT.0) THEN
            DO 340 I=1,NOBS
               U(I)=ET(I)+U(I)    
  340       CONTINUE
         END IF   
C         COMPUTE SIMULATED WEIGHTED RESIDUALS D AS CORRELATED NORMAL
C         RANDOM VARIABLES
         DO 380 J=1,NTOT
            SUM=0.0
            DO 370 I=1,NTOT
               SUM=SUM+R(I,J)*U(I)
  370       CONTINUE
            D(J)=SUM
  380    CONTINUE
C         PRINT D, IF SPECIFIED
         IF (IPRN.GT.0) THEN
            WRITE(IOUT,1110) IS
            WRITE(IOUT,1138)
            CALL PRTOTA(DID,D,NTOT)
         ENDIF
C         COMPUTE ORDERED, SIMULATED WEIGHTED RESIDUALS AND THEIR FIRST
C         TWO MOMENTS
         DO 420 I=1,NTOT          
            DI=D(I)
            DO 410 J=I,NTOT
               IF (D(J).LT.DI) THEN
                  TMP=DI
                  DI=D(J)
                  D(J)=TMP
               ENDIF
  410       CONTINUE
            D(I)=DI
            DM(I)=DM(I)+DI
            DV(I)=DV(I)+DI*DI
  420    CONTINUE
         WRITE(ISCR) (D(I),I=1,NTOT)
C         PRINT ORDERED D, IF SPECIFIED
         IF(IPRN.GT.0) THEN
            WRITE(IOUT,1140)
            CALL PRTOTD2(DID1,D,FRQ,NTOT)
         ENDIF
  430 CONTINUE
C         COMPUTE AND PRINT MEANS AND STANDARD DEVIATIONS OF D                  
      RN=NSETS
      RNM1=NSETS-1
      DMM=0.
      DO 440 I=1,NTOT
         DM(I)=DM(I)/RN
         DMM=DMM+DM(I)
         DV(I)=SQRT((DV(I)-RN*DM(I)*DM(I))/RNM1)
  440 CONTINUE
      DMM=DMM/RNT
      WRITE(IOUT,1142)
      CALL PRTOTD2(DID1,DM,FRQ,NTOT)
      WRITE(IOUT,1144)
      CALL PRTOTD2(DID1,DV,FRQ,NTOT)
      WRITE(IPLOTD,1470)
      WRITE(IPLOTD,1480) (E(I),DM(I),DV(I),2*DV(I),FRQ(I),BUFF2(I),
     &                    DID1(I),ISYM(I),I=1,NTOT)
C         COMPUTE THE CUMULATIVE DISTRIBUTION FOR THE CORRELATIONS
      REWIND ISCR
      DO 470 IS=1,NSETS
         READ(ISCR) (D(I),I=1,NTOT)
         DIM=0.
         DO 450 I=1,NTOT
            DIM=DIM+D(I)
  450    CONTINUE
         DIM=DIM/RNT
         DDM=0.
         DVR=0.
         DMVR=0.
         DO 460 I=1,NTOT
            TMP=D(I)-DIM
            TMPA=DM(I)-DMM
            DDM=DDM+TMP*TMPA
            DVR=DVR+TMP*TMP
            DMVR=DMVR+TMPA*TMPA
  460    CONTINUE
         CE(IS)=DDM*DDM/(DVR*DMVR)
  470 CONTINUE
      DO 490 I=1,NSETS
         CEI=CE(I)
         DO 480 J=I,NSETS
            IF (CE(J).LT.CEI) THEN
               TMP=CEI
               CEI=CE(J)
               CE(J)=TMP
            ENDIF
  480    CONTINUE 
         CE(I)=CEI
  490 CONTINUE
C         COMPUTE THE CONFIDENCE LIMITS  
      IC1=.99*RN
      IC2=.95*RN
      IC3=.90*RN
      IC4=0.1*rn
      IC5=.05*rn
      IC6=.01*rn
      CL99=SQRT(CE(IC1)) 
      CL95=SQRT(CE(IC2)) 
      CL90=SQRT(CE(IC3))
C         COMPUTE THE CORRELATION OF THE WEIGHTED RESIDUALS AND THE
C         MEAN SIMULATED RESIDUALS; COMPUTE THE PROBABILITY OF ITS
C         OCCURRENCE       
      ED=0.
      EVR=0.
      DMVR=0.
      DO 500 I=1,NTOT
         TMP=E(I)-EM
         TMPA=DM(I)-DMM
         ED=ED+TMP*TMPA
         EVR=EVR+TMP*TMP
         DMVR=DMVR+TMPA*TMPA
  500 CONTINUE
      CED=ED*ED/(EVR*DMVR)
      DO 510 IS=1,NSETS
         IC=IS
         IF(CED.LT.CE(IS)) GO TO 520
  510 CONTINUE
  520 PROB=IC/RN
      CED=SQRT(CED)
C         PRINT CORRELATION, PROBABILITY, AND CONFIDENCE LIMITS      
      WRITE(IOUT,1146) CED,PROB,CL99,CL95,CL90
C         PRINT THE IDENTITY MINUS HAT MATRIX, IF SPECIFIED
  530 IF(IPCF.GT.0) THEN
         WRITE(IOUT,1148)
         CALL URESPM(R,NTOT,8,IOUT,DID,NALL)
      ENDIF
C
      END
C=======================================================================
      SUBROUTINE PRTOT(C,NR,NC,NRD)
C**PRINT MATRICES AND VECTORS
      DIMENSION C(1)
      COMMON/ITP/IIN,IOUT
      IF(NC.EQ.1) GO TO 25
      DO 20 L=1,NC,10
      J10=L+9
      IF(J10.GT.NC) J10=NC
      WRITE(IOUT,35) (J,J=L,J10)
      WRITE(IOUT,50)
      KBC=(L-1)*NRD
      KEC=(J10-1)*NRD
      DO 10 I=1,NR
      KB=KBC+I
      KE=KEC+I
   10 WRITE(IOUT,40) I,(C(K),K=KB,KE,NRD)
   20 CONTINUE
      RETURN
   25 N=NR/3
      IF((3*N).NE.NR) N=N+1
      DO 30 K=1,N
   30 WRITE(IOUT,80) (L,C(L),L=K,NR,N)
      RETURN
   35 FORMAT ('0',10(8X,I4))
   40 FORMAT (1X,I4,10(1X,G11.5))
   50 FORMAT (' ')
   80 FORMAT (3X,3(I4,6X,G11.5,3X))
      END
C=======================================================================
      SUBROUTINE PRTOTA(DID,VALB,NO)
C**PRINT VALUES IN TWO GROUPS OF THREE COLUMNS
      CHARACTER*12DID(NO)
      DIMENSION VALB(NO)
      COMMON/ITP/IIN,IOUT
      NR=NO/2
      IF(2*NR.NE.NO) NR=NR+1
      DO 10 K=1,NR
      WRITE(IOUT,20) (L,DID(L),VALB(L),L=K,NO,NR)
   10 CONTINUE
      RETURN
   20 FORMAT (2X,2(I4,2X,A,1X,G11.5,2X))
      END
C=======================================================================
      SUBROUTINE PRTOTD2(DID,VALA,VALB,NO)
C**PRINT VALUES IN TWO GROUPS OF THREE COLUMNS
      CHARACTER*12 DID(NO)
      DIMENSION VALA(NO),VALB(NO)
      COMMON/ITP/IIN,IOUT
      DO 10 L=1,NO
        WRITE(IOUT,20) L,DID(L),VALA(L),VALB(L)
   10 CONTINUE
      RETURN
   20 FORMAT (3X,I4,3X,A,3X,G11.5,3X,G11.5)
      END
C=======================================================================
      SUBROUTINE PRTOTX(X,NR,NC,NRD,DID,PARNAM)
C**PRINT MATRICES DIVIDED VERTICALLY INTO FIVE-COLUMN BLOCKS
      INTEGER I, IIN1, IOUT, J, J10, K, NC, NR, NRD
      DIMENSION X(NRD,NC)
      CHARACTER*10 PARNAM(NR)
      CHARACTER*12 DID(NC)
      COMMON /ITP   / IIN1, IOUT
      DO 20 K = 1, NC, 5
        J10 = K + 4
        IF (J10.GT.NC) J10 = NC
        WRITE (IOUT,500) (DID(J),J=K,J10)
        WRITE (IOUT,510) ('------------',J=K,J10)
        DO 10 I = 1, NR
          WRITE (IOUT,505) PARNAM(I), (X(I,J),J=K,J10)
   10   CONTINUE
   20 CONTINUE
  500 FORMAT (/,1X,'PARAMETER',3X,5(A12,1X))
  505 FORMAT (1X,A10,2X,5(G12.5,1X))
  510 FORMAT (1X,10('-'),2X,5(A12,1X))
      RETURN
      END
C=======================================================================
      SUBROUTINE UNORM(U,RNORM,IP)
C-----VERSION 19981117 ERB
C     ******************************************************************
C     FIND THE PROBABILITY RELATED TO A U (IP=1), OR A U RELATED TO A
C     PROBABILITY (IP=-1) FOR A STANDARD GAUSSIAN DISTRIBUTION
C     ******************************************************************
C        SPECIFICATIONS:
      REAL AU
      INTEGER I, IP
      DIMENSION PNORM(2,54)
C     ------------------------------------------------------------------
      DATA (PNORM(1,I),I=1,54)/0.0, .15, .20, .25, .30, .35, .40, .45, 
     &      .50, .55, .60, .65, .70, .75, .80, .85, .90, .95, 1.00, 
     &      1.05, 1.10, 1.15, 1.20, 1.25, 1.30, 1.35, 1.40, 1.45, 1.50, 
     &      1.55, 1.60, 1.65, 1.70, 1.75, 1.80, 1.85, 1.90, 1.95, 2.0,
     &      2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9, 3.0, 3.5, 4.0,
     &      4.5, 5.0, 5.5/
      DATA (PNORM(2,I),I=1,54)/.5, .5596, .5793, .5987, .6179, .6368, 
     &      .6554, .6736, .6915, .7088, .7257, .7422, .7580, .7734, 
     &      .7881, .8023, .8159, .8289, .8413, .8531, .8643, .8749, 
     &      .8849, .8944, .90320, .91149, .91924, .92647, .93319, 
     &      .93943, .94520, .95053, .95543, .95994, .96407, .96784, 
     &      .97128, .97441, .9772, .9821, .98610, .9893, .9918, .9938,
     &      .9953, .9965, .9974, .9981, .9987, .99976737,  .99996833,
     &      .99999660, .99999971, 1.0/
C     ------------------------------------------------------------------
C
C-----GIVEN U, GET THE CUMULATIVE PROBABILITY
      IF (IP.EQ.1) THEN
C-------FIND THE VALUES ABOVE AND BELOW U
        AU = ABS(U)
        IF (AU.GE.5.5) THEN
          RNORM = 1.0
          IF (U.LT.0.0) RNORM = 0.0
        ELSE
          DO 10 I = 1, 53
            IF (AU.GE.PNORM(1,I) .AND. AU.LT.PNORM(1,I+1)) THEN
C-------INTERPOLATE
              FACTOR = (AU-PNORM(1,I))/(PNORM(1,I+1)-PNORM(1,I))
              RNORM = PNORM(2,I) + FACTOR*(PNORM(2,I+1)-PNORM(2,I))
              IF (U.LT.0) RNORM = 1.0 - RNORM
              GOTO 30
            ENDIF
   10     CONTINUE
          STOP 'ERROR IN UNORM -- U NOT FOUND'
        ENDIF
C-----GIVEN THE CUMULATIVE PROBABILITY, GET U
      ELSEIF (IP.EQ.-1) THEN
C-------FIND THE VALUES ABOVE AND BELOW RNORM
        ARNORM = RNORM
        IF (RNORM.LT..50) ARNORM = 1. - RNORM
        IF (ARNORM.EQ.1.0) THEN
          U = 5.5
          IF (RNORM.LT..5) U = -5.5
        ELSE
          DO 20 I = 1, 53
            IF (ARNORM.GE.PNORM(2,I) .AND. ARNORM.LT.PNORM(2,I+1)) THEN
C-------INTERPOLATE
              FACTOR = (ARNORM-PNORM(2,I))/(PNORM(2,I+1)-PNORM(2,I))
              U = PNORM(1,I) + FACTOR*(PNORM(1,I+1)-PNORM(1,I))
              IF (RNORM.LT..50) U = -U
              GOTO 30
            ENDIF
   20     CONTINUE
          STOP 'ERROR IN UNORM -- RNORM NOT FOUND'
        ENDIF
      ENDIF
   30 RETURN
      END
C=======================================================================
      FUNCTION RANUM(MA,IK,IKP,IRAN)
C         RETURNS A UNIFORM (0,1) RANDOM NUMBER
      IMPLICIT REAL (M)
      DIMENSION MA(55)
      MBIG=4000000.
      MS=1618033.
      MZ=0.
      IF(IRAN.GT.0) GO TO 40
      IRAN=-IRAN
      MJ=MS-IRAN
      MJ=MOD(MJ,MBIG)
      MA(55)=MJ
      MK=1.
      DO 10 I=1,54
      II=MOD(21*I,55)
      MA(II)=MK
      MK=MJ-MK
      IF(MK.LT.MZ) MK=MK+MBIG
      MJ=MA(II)
   10 CONTINUE
      DO 30 K=1,4
      DO 20 I=1,55
      II=1+MOD(I+30,55)
      MA(I)=MA(I)-MA(II)
      IF(MA(I).LT.MZ) MA(I)=MA(I)+MBIG
   20 CONTINUE
   30 CONTINUE
      IK=0
      IKP=31
      IRAN=1
   40 IK=IK+1
      IF(IK.EQ.56) IK=1
      IKP=IKP+1
      IF(IKP.EQ.56) IKP=1
      MJ=MA(IK)-MA(IKP)
      IF(MJ.LT.MZ) MJ=MJ+MBIG
      MA(IK)=MJ
      RANUM=MJ/MBIG
      RETURN
      END
C=======================================================================
      FUNCTION RNDV(RNSV,AM,IK,IKP,IRAN,ISET)
C         RETURNS A NORMAL, N(0,1), RANDOM VARIABLE
      DIMENSION AM(55)
      IF(ISET.GT.0) GO TO 20
   10 V1=2.*RANUM(AM,IK,IKP,IRAN)-1.
      V2=2.*RANUM(AM,IK,IKP,IRAN)-1.
      R=V1*V1+V2*V2
      IF(R.GE.1.) GO TO 10
      FAC=SQRT(-2.*ALOG(R)/R)
      RNSV=V1*FAC
      RNDV=V2*FAC
      ISET=1
      RETURN
   20 RNDV=RNSV
      ISET=0
      RETURN
      END
C=======================================================================
      INTEGER FUNCTION NONB_LEN(CHARVAR,LENGTH)
C
C FUNCTION TO RETURN NON-BLANK LENGTH OF CONTENTS OF A CHARACTER VARIABLE
C
C Variable list:
C   CHARVAR  = CHARACTER VARIABLE OF INTEREST
C   LENGTH   = DIMENSIONED LENGTH OF CHARVAR
C
      CHARACTER*(*) CHARVAR,C*1
      INTEGER LENGTH
C
      C = ' '
      K = LENGTH+1
C
      DO 20 WHILE (C .EQ. ' ' .AND. K .GE. 1)
        K = K-1
        C = CHARVAR(K:K)
 20   CONTINUE
C
      NONB_LEN = K
      RETURN
      END
C=======================================================================
      SUBROUTINE FINDINP(IOUT,OUTNAM,INWR)
C
      CHARACTER*80 NAMFIL, OBFNAM, OUTNAM, OUTNAMU
      CHARACTER*200 LINE
      LOGICAL EXISTS
      DOUBLE PRECISION R
C
C     NAMFIL is the name of the name file
C     OBFNAM is the name of the OBS file
C     OUTNAM is the name of the output filename base listed in
C            the OBS file
C     OUTNAMU is an upper-case version of OUTNAM, for comparison
C            with 'NONE'
C
  500 FORMAT(' Enter the name of the NAME file:',/)
  510 FORMAT(' The NAME file is: ',A)
  520 FORMAT(A)
  530 FORMAT(/,' Error reading NAME file.  Enter blank line to quit.',/)
  540 FORMAT(/,' Error opening NAME file.  Enter blank line to quit.',/)
  550 FORMAT(/,' Error opening file "',A,'"')
C
    1 CONTINUE
      NAMFIL = ' '
      ISTAT = 0
C *** The following statement should be uncommented in order to use
C *** GETARG to retrieve a command line argument.
      CALL GETARG(1,NAMFIL)
      IF(NAMFIL.NE.' ') THEN
        INQUIRE (FILE=NAMFIL,EXIST=EXISTS)
        IF(.NOT.EXISTS) THEN
          NC=INDEX(NAMFIL,' ')
          NAMFIL(NC:NC+3)='.nam'
          INQUIRE (FILE=NAMFIL,EXIST=EXISTS)
          IF(.NOT.EXISTS) THEN
            WRITE(*,*) ' Name file does not exist'
            STOP
          ENDIF
        ENDIF
      ELSE
        WRITE(*,500)
        READ(*,520,ERR=5,IOSTAT=ISTAT) NAMFIL
      ENDIF
      IF (NAMFIL.EQ.' ') STOP
    5 CONTINUE
      IF (ISTAT.NE.0) THEN
        WRITE(*,530)
        GOTO 1
      ENDIF
      OPEN(INWR,FILE=NAMFIL,STATUS='OLD',ERR=7,IOSTAT=ISTAT)
    7 CONTINUE
      IF (ISTAT.NE.0) THEN
        WRITE(*,540)
        GOTO 1
      ENDIF
      WRITE(*,510) NAMFIL
C
      OUTNAM=' '
   10 CONTINUE
C       Read down in NAME file to find name of OBS file
        CALL URDCOM(INWR,IOUT,LINE,ISTAT)
        IF (ISTAT.EQ.1) THEN
C         END-OF-FILE reached
          OUTNAM='NONE'
          GOTO 40
        ENDIF
        LLOC = 1
C       Look for OBS file type in the name file
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INWR)
        IF (LINE(ISTART:ISTOP).EQ.'OBS') THEN
C         Assign OBFNAM as the name of the OBS file, read from the NAME
C         file
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INWR)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,INWR)
          OBFNAM = LINE(ISTART:ISTOP)
          CLOSE(INWR)
          OPEN(INWR,FILE=OBFNAM,STATUS='OLD',ERR=20,IOSTAT=ISTAT)
   20     CONTINUE
          IF (ISTAT.NE.0) THEN
            NLEN = NONB_LEN(OBFNAM,80)
            WRITE(*,550) OBFNAM(1:NLEN)
            STOP
          ENDIF
C         Assign OUTNAM as filename base read from OBS file
          CALL URDCOM(INWR,IOUT,LINE,ISTAT)
          LLOC = 1
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,INWR)
          OUTNAM = LINE(ISTART:ISTOP)
          CLOSE(INWR)
          CALL UCASE(OUTNAM,OUTNAMU,1)
          IF (OUTNAMU.EQ.'NONE') OUTNAM = 'NONE'
          GOTO 40
        ENDIF
      GOTO 10
C
   40 CONTINUE
      RETURN
      END
C=======================================================================
      SUBROUTINE URDCOM(IN,IOUT,LINE,ISTAT)
C
C-----VERSION 02FEB1999 URDCOM
C     ******************************************************************
C     READ COMMENTS FROM A FILE AND PRINT THEM.  RETURN THE FIRST LINE
C     THAT IS NOT A COMMENT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*(*) LINE
C     ------------------------------------------------------------------
      ISTAT=0
   10 READ(IN,'(A)',END=40,ERR=50) LINE
      IF(LINE(1:1).NE.'#') RETURN
      L=LEN(LINE)
      IF(L.GT.79) L=79
      DO 20 I=L,1,-1
      IF(LINE(I:I).NE.' ') GO TO 30
   20 CONTINUE
   30 WRITE(IOUT,'(1X,A)') LINE(1:I)
      GO TO 10
C
C     FLAG END OF FILE
   40 CONTINUE
      ISTAT=1
      RETURN
C
C     FLAG READ ERROR
   50 CONTINUE
      ISTAT=2
      RETURN
      END
C=======================================================================
      SUBROUTINE URWORD(LINE,ICOL,ISTART,ISTOP,NCODE,N,R,IOUT,IN)
C
C
C-----VERSION 1003 05AUG1992 URWORD
C     ******************************************************************
C     ROUTINE TO EXTRACT A WORD FROM A LINE OF TEXT, AND OPTIONALLY
C     CONVERT THE WORD TO A NUMBER.
C        ISTART AND ISTOP WILL BE RETURNED WITH THE STARTING AND
C          ENDING CHARACTER POSITIONS OF THE WORD.
C        THE LAST CHARACTER IN THE LINE IS SET TO BLANK SO THAT IF ANY
C          PROBLEMS OCCUR WITH FINDING A WORD, ISTART AND ISTOP WILL
C          POINT TO THIS BLANK CHARACTER.  THUS, A WORD WILL ALWAYS BE
C          RETURNED UNLESS THERE IS A NUMERIC CONVERSION ERROR.  BE SURE
C          THAT THE LAST CHARACTER IN LINE IS NOT AN IMPORTANT CHARACTER
C          BECAUSE IT WILL ALWAYS BE SET TO BLANK.
C        A WORD STARTS WITH THE FIRST CHARACTER THAT IS NOT A SPACE OR
C          COMMA, AND ENDS WHEN A SUBSEQUENT CHARACTER THAT IS A SPACE
C          OR COMMA.  NOTE THAT THESE PARSING RULES DO NOT TREAT TWO
C          COMMAS SEPARATED BY ONE OR MORE SPACES AS A NULL WORD.
C        FOR A WORD THAT BEGINS WITH "'", THE WORD STARTS WITH THE
C          CHARACTER AFTER THE QUOTE AND ENDS WITH THE CHARACTER
C          PRECEDING A SUBSEQUENT QUOTE.  THUS, A QUOTED WORD CAN
C          INCLUDE SPACES AND COMMAS.  THE QUOTED WORD CANNOT CONTAIN
C          A QUOTE CHARACTER.
C        IF NCODE IS 1, THE WORD IS CONVERTED TO UPPER CASE.
C        IF NCODE IS 2, THE WORD IS CONVERTED TO AN INTEGER.
C        IF NCODE IS 3, THE WORD IS CONVERTED TO A REAL NUMBER.
C        NUMBER CONVERSION ERROR IS WRITTEN TO UNIT IOUT IF IOUT IS
C          POSITIVE; ERROR IS WRITTEN TO DEFAULT OUTPUT IF IOUT IS 0;
C          NO ERROR MESSAGE IS WRITTEN IF IOUT IS NEGATIVE.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*(*) LINE
      CHARACTER*20 RW,STRING
      DOUBLE PRECISION R
C     ------------------------------------------------------------------
C
C1------Set last char in LINE to blank and set ISTART and ISTOP to point
C1------to this blank as a default situation when no word is found.  If
C1------starting location in LINE is out of bounds, do not look for a
C1------word.
      LINLEN=LEN(LINE)
      LINE(LINLEN:LINLEN)=' '
      ISTART=LINLEN
      ISTOP=LINLEN
      LINLEN=LINLEN-1
      IF(ICOL.LT.1 .OR. ICOL.GT.LINLEN) GO TO 100
C
C2------Find start of word, which is indicated by first character that
C2------is not a blank and not a comma.
      DO 10 I=ICOL,LINLEN
      IF(LINE(I:I).NE.' ' .AND. LINE(I:I).NE.',') GO TO 20
10    CONTINUE
      ICOL=LINLEN+1
      GO TO 100
C
C3------Found start of word.  Look for end.
C3A-----When word is quoted, only a quote can terminate it.
20    IF(LINE(I:I).EQ.'''') THEN
         I=I+1
         IF(I.LE.LINLEN) THEN
            DO 25 J=I,LINLEN
            IF(LINE(J:J).EQ.'''') GO TO 40
25          CONTINUE
         END IF
C
C3B-----When word is not quoted, space or comma will terminate.
      ELSE
         DO 30 J=I,LINLEN
         IF(LINE(J:J).EQ.' ' .OR. LINE(J:J).EQ.',') GO TO 40
30       CONTINUE
      END IF
C
C3C-----End of line without finding end of word; set end of word to
C3C-----end of line.
      J=LINLEN+1
C
C4------Found end of word; set J to point to last character in WORD and
C-------set ICOL to point to location for scanning for another word.
40    ICOL=J+1
      J=J-1
      IF(J.LT.I) GO TO 100
      ISTART=I
      ISTOP=J
C
C5------Convert word to upper case and RETURN if NCODE is 1.
      IF(NCODE.EQ.1) THEN
         IDIFF=ICHAR('a')-ICHAR('A')
         DO 50 K=ISTART,ISTOP
            IF(LINE(K:K).GE.'a' .AND. LINE(K:K).LE.'z')
     1             LINE(K:K)=CHAR(ICHAR(LINE(K:K))-IDIFF)
50       CONTINUE
         RETURN
      END IF
C
C6------Convert word to a number if requested.
100   IF(NCODE.EQ.2 .OR. NCODE.EQ.3) THEN
         RW=' '
         L=20-ISTOP+ISTART
         IF(L.LT.1) GO TO 200
         RW(L:20)=LINE(ISTART:ISTOP)
         IF(NCODE.EQ.2) READ(RW,'(I20)',ERR=200) N
         IF(NCODE.EQ.3) READ(RW,'(F20.0)',ERR=200) R
      END IF
      RETURN
C
C7------Number conversion error.
200   IF(NCODE.EQ.3) THEN
         STRING= 'A REAL NUMBER'
         L=13
      ELSE
         STRING= 'AN INTEGER'
         L=10
      END IF
C
C7A-----If output unit is negative, set last character of string to 'E'.
      IF(IOUT.LT.0) THEN
         N=0
         R=0.
         LINE(LINLEN+1:LINLEN+1)='E'
         RETURN
C
C7B-----If output unit is positive; write a message to output unit.
      ELSE IF(IOUT.GT.0) THEN
         IF(IN.GT.0) THEN
            WRITE(IOUT,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(IOUT,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
201      FORMAT(1X,/1X,'FILE UNIT',I4,' : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
202      FORMAT(1X,/1X,'KEYBOARD INPUT : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
C
C7C-----If output unit is 0; write a message to default output.
      ELSE
         IF(IN.GT.0) THEN
            WRITE(*,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(*,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
      END IF
C
C7D-----STOP after writing message.
      STOP
      END
C=======================================================================
      SUBROUTINE UCASE(WORDIN,WORDOUT,ICASE)
C     VERSION 19980316 ERB
C     ******************************************************************
C     CONVERT A CHARACTER STRING TO ALL UPPER (ICASE > 0) OR ALL
C     LOWER (ICASE < 0) CASE.  IF ICASE = 0, NO CASE CONVERSION IS DONE.
C     ******************************************************************
C       SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER WORDIN*(*), WORDOUT*(*)
      INTEGER ICASE, LENGNB, LENGIN, LENGOUT
C
C     DETERMINE LENGTH OF STRING VARIABLES
      LENGIN = LEN(WORDIN)
      LENGOUT = LEN(WORDOUT)
C
C     DETERMINE IF WORDOUT IS LONG ENOUGH TO CONTAIN NON-BLANK LENGTH
C     OF WORDIN
      LENGNB = NONB_LEN(WORDIN,LENGIN)
      IF (LENGNB.GT.LENGOUT) STOP 'STRING-LENGTH ERROR IN UCASE'
C
      WORDOUT = WORDIN
      IDIFF=ICHAR('a')-ICHAR('A')
      IF (ICASE.GT.0) THEN
C       CONVERT STRING TO UPPER CASE
        DO 10 K=1,LENGNB
          IF(WORDIN(K:K).GE.'a' .AND. WORDIN(K:K).LE.'z')
     1      WORDOUT(K:K)=CHAR(ICHAR(WORDIN(K:K))-IDIFF)
10      CONTINUE
C
      ELSEIF (ICASE.LT.0) THEN
C       CONVERT STRING TO LOWER CASE
        DO 20 K=1,LENGNB
          IF(WORDIN(K:K).GE.'A' .AND. WORDIN(K:K).LE.'Z')
     1      WORDOUT(K:K)=CHAR(ICHAR(WORDIN(K:K))+IDIFF)
20      CONTINUE
C
      ENDIF
C
      RETURN
      END
C=======================================================================
      SUBROUTINE UPARPM(BUF,NPE,IPRC,IOUT,PARNAM,NPD)
C
C-----VERSION 19980825 ERB
C     ******************************************************************
C     PRINT ONE NPE*NPE CORRELATION OR VARIANCE-COVARIANCE MATRIX
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*10 PARNAM(NPE)
      DOUBLE PRECISION BUF
      DIMENSION BUF(NPD,NPD)
C     ------------------------------------------------------------------
C
C2------MAKE SURE THE FORMAT CODE (IPRC) IS VALID
      IP=IPRC
      IF(IP.LT.1 .OR. IP.GT.10) IP=1
C
C3------LABEL COLUMNS WITH PARAMETER NAMES.
      IF(IP.EQ.1) CALL UCOLLBL(1,NPE,0,11,11,IOUT,PARNAM,NPE)
      IF(IP.EQ.2) CALL UCOLLBL(1,NPE,0,10,12,IOUT,PARNAM,NPE)
      IF(IP.EQ.3) CALL UCOLLBL(1,NPE,0,9,13,IOUT,PARNAM,NPE)
      IF(IP.EQ.4) CALL UCOLLBL(1,NPE,0,8,14,IOUT,PARNAM,NPE)
      IF(IP.EQ.5) CALL UCOLLBL(1,NPE,0,8,15,IOUT,PARNAM,NPE)
      IF(IP.EQ.6) CALL UCOLLBL(1,NPE,0,6,11,IOUT,PARNAM,NPE)
      IF(IP.EQ.7) CALL UCOLLBL(1,NPE,0,5,12,IOUT,PARNAM,NPE)
      IF(IP.EQ.8) CALL UCOLLBL(1,NPE,0,5,13,IOUT,PARNAM,NPE)
      IF(IP.EQ.9) CALL UCOLLBL(1,NPE,0,4,14,IOUT,PARNAM,NPE)
      IF(IP.EQ.10 ) CALL UCOLLBL(1,NPE,0,4,15,IOUT,PARNAM,NPE)
C
C4------LOOP THROUGH THE ROWS PRINTING EACH ONE IN ITS ENTIRETY.
      DO 1000 I=1,NPE
C
C------------ FORMAT 11G10.3
        IF (IP.EQ.1) THEN 
          WRITE(IOUT,11) PARNAM(I),(BUF(J,I),J=1,NPE)
   11     FORMAT(1X,A,1X,1PG10.3,10(1X,G10.3):/(11X,11(1X,G10.3)))
C
C------------ FORMAT 10G11.4
        ELSEIF (IP.EQ.2) THEN
          WRITE(IOUT,21) PARNAM(I),(BUF(J,I),J=1,NPE)
   21     FORMAT(1X,A,1X,1PG11.4,9(1X,G11.4):/(11X,10(1X,G11.4)))
C
C------------ FORMAT 9G12.5
        ELSEIF (IP.EQ.3) THEN
          WRITE(IOUT,31) PARNAM(I),(BUF(J,I),J=1,NPE)
   31     FORMAT(1X,A,1X,1PG12.5,8(1X,G12.5):/(11X,9(1X,G12.5)))
C
C------------ FORMAT 8G13.6
        ELSEIF (IP.EQ.4) THEN
          WRITE(IOUT,41) PARNAM(I),(BUF(J,I),J=1,NPE)
   41     FORMAT(1X,A,1X,1PG13.6,7(1X,G13.6):/(11X,8(1X,G13.6)))
C
C------------ FORMAT 8G14.7
        ELSEIF (IP.EQ.5) THEN
          WRITE(IOUT,51) PARNAM(I),(BUF(J,I),J=1,NPE)
   51     FORMAT(1X,A,1X,1PG14.7,7(1X,G14.7):/(11X,8(1X,G14.7)))
C
C------------ FORMAT 6G10.3
        ELSEIF (IP.EQ.6) THEN 
          WRITE(IOUT,61) PARNAM(I),(BUF(J,I),J=1,NPE)
   61     FORMAT(1X,A,1X,1PG10.3,5(1X,G10.3):/(11X,6(1X,G10.3)))
C
C------------ FORMAT 5G11.4
        ELSEIF (IP.EQ.7) THEN
          WRITE(IOUT,71) PARNAM(I),(BUF(J,I),J=1,NPE)
   71     FORMAT(1X,A,1X,1PG11.4,4(1X,G11.4):/(11X,5(1X,G11.4)))
C
C------------ FORMAT 5G12.5
        ELSEIF (IP.EQ.8) THEN
          WRITE(IOUT,81) PARNAM(I),(BUF(J,I),J=1,NPE)
   81     FORMAT(1X,A,1X,1PG12.5,4(1X,G12.5):/(11X,5(1X,G12.5)))
C
C------------ FORMAT 4G13.6
        ELSEIF (IP.EQ.9) THEN
          WRITE(IOUT,91) PARNAM(I),(BUF(J,I),J=1,NPE)
   91     FORMAT(1X,A,1X,1PG13.6,3(1X,G13.6):/(11X,4(1X,G13.6)))
C
C------------ FORMAT 4G14.7
        ELSEIF (IP.EQ.10) THEN
          WRITE(IOUT,101) PARNAM(I),(BUF(J,I),J=1,NPE)
  101     FORMAT(1X,A,1X,1PG14.7,3(1X,G14.7):/(11X,4(1X,G14.7)))
C
        ENDIF
 1000 CONTINUE
C
C5------RETURN
      RETURN
      END
C **********************************************************************
      SUBROUTINE UCOLLBL(NLBL1,NLBL2,NSPACE,NCPL,NDIG,IOUT,PARNAM,NPE)
C
C-----VERSION 19980825 ERB
C     ******************************************************************
C     LABEL THE COLUMNS OF MATRIX PRINTOUT WITH PARAMETER NAMES
C        NLBL1 IS THE START COLUMN (NUMBER)
C        NLBL2 IS THE STOP COLUMN (NUMBER)
C        NSPACE IS NUMBER OF BLANK SPACES TO LEAVE AT START OF LINE
C        NCPL IS NUMBER OF COLUMNS PER LINE
C        NDIG IS NUMBER OF CHARACTERS IN EACH COLUMN FIELD
C        IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*1 DOT, SPACE, BF*200
      CHARACTER*10 PARNAM(NPE)
C
      DATA DOT,SPACE/'.',' '/
C     ------------------------------------------------------------------
C
C1------CALCULATE # OF COLUMNS TO BE PRINTED (NLBL), WIDTH
C1------OF A LINE (NTOT), NUMBER OF LINES (NWRAP).
      WRITE(IOUT,1)
    1 FORMAT(1X)
      NLBL = NLBL2-NLBL1+1
      N = NLBL
      IF(NLBL.GT.NCPL) N = NCPL
      LENPN = LEN(PARNAM(1))
      MINCOLSP = LENPN+1
      IF (NDIG.LT.MINCOLSP) THEN
        WRITE(IOUT,200) NDIG,MINCOLSP
 200    FORMAT(' SPECIFIED FIELD WIDTH TOO SMALL FOR PARNAM',
     &         '--STOP EXECUTION (UCOLLBL)',/
     &         ' NDIG = ',I2,'   MINCOLSP = ',I2)
        STOP
      ENDIF
      NTOT = NSPACE+LENPN+N*NDIG
      IND = (NDIG-LENPN-1)/2
      NWRAP = (NLBL-1)/NCPL+1
      J1 = NLBL1-NCPL
      J2 = NLBL1-1
C
C2------BUILD AND PRINT EACH LINE
      DO 40 N=1,NWRAP
C
C3------CLEAR THE BUFFER (BF).
        DO 20 I=1,130
          BF(I:I)=SPACE
   20   CONTINUE
        NBF = MINCOLSP+1+IND-NDIG
C
C4------DETERMINE FIRST (J1) AND LAST (J2) COLUMN # FOR THIS LINE.
        J1=J1+NCPL
        J2=J2+NCPL
        IF(J2.GT.NLBL2) J2=NLBL2
C5------LOAD THE COLUMN LABELS INTO THE BUFFER.
        DO 30 J=J1,J2
          NBF=NBF+NDIG
          NBF2 = NBF+LENPN-1
          BF(NBF:NBF2) = PARNAM(J)
   30   CONTINUE
C
C6------PRINT THE CONTENTS OF THE BUFFER (I.E. PRINT THE LINE).
        WRITE(IOUT,31) BF(1:NBF2)
   31   FORMAT(1X,A)
C
   40 CONTINUE
C
C7------PRINT A LINE OF DOTS (FOR ESTHETIC PURPOSES ONLY).
   50 CONTINUE
      WRITE(IOUT,51) (DOT,I=1,NTOT)
   51 FORMAT(1X,200A1)
C
C8------RETURN
      RETURN
      END
C=======================================================================
      SUBROUTINE URESPM(BUF,NTOT,IPRC,IOUT,DID,NDQP)
C
C-----VERSION 19980825 ERB
C     ******************************************************************
C     PRINT ONE NTOT*NTOT CORRELATION OR VARIANCE-COVARIANCE MATRIX FOR
C     RESIDUALS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*12 DID(NTOT)
      DIMENSION BUF(NDQP,NDQP)
C     ------------------------------------------------------------------
C
C2------MAKE SURE THE FORMAT CODE (IPRC) IS VALID
      IP=IPRC
      IF(IP.LT.1 .OR. IP.GT.10) IP=1
C
C3------LABEL COLUMNS WITH PARAMETER NAMES.
      IF(IP.EQ.1) CALL UCOLLBLR(1,NTOT,0,11,11,IOUT,DID,NTOT)
      IF(IP.EQ.2) CALL UCOLLBLR(1,NTOT,0,10,12,IOUT,DID,NTOT)
      IF(IP.EQ.3) CALL UCOLLBLR(1,NTOT,0,9,13,IOUT,DID,NTOT)
      IF(IP.EQ.4) CALL UCOLLBLR(1,NTOT,0,8,14,IOUT,DID,NTOT)
      IF(IP.EQ.5) CALL UCOLLBLR(1,NTOT,0,8,15,IOUT,DID,NTOT)
      IF(IP.EQ.6) CALL UCOLLBLR(1,NTOT,0,6,11,IOUT,DID,NTOT)
      IF(IP.EQ.7) CALL UCOLLBLR(1,NTOT,0,5,12,IOUT,DID,NTOT)
      IF(IP.EQ.8) CALL UCOLLBLR(1,NTOT,0,5,13,IOUT,DID,NTOT)
      IF(IP.EQ.9) CALL UCOLLBLR(1,NTOT,0,4,14,IOUT,DID,NTOT)
      IF(IP.EQ.10 ) CALL UCOLLBLR(1,NTOT,0,4,15,IOUT,DID,NTOT)
C
C4------LOOP THROUGH THE ROWS PRINTING EACH ONE IN ITS ENTIRETY.
      DO 1000 I=1,NTOT
C
C------------ FORMAT 11G10.3
        IF (IP.EQ.1) THEN 
          WRITE(IOUT,11) DID(I),(BUF(J,I),J=1,NTOT)
   11     FORMAT(1X,A,1X,1PG10.3,10(1X,G10.3):/(13X,11(1X,G10.3)))
C
C------------ FORMAT 10G11.4
        ELSEIF (IP.EQ.2) THEN
          WRITE(IOUT,21) DID(I),(BUF(J,I),J=1,NTOT)
   21     FORMAT(1X,A,1X,1PG11.4,9(1X,G11.4):/(13X,10(1X,G11.4)))
C
C------------ FORMAT 9G12.5
        ELSEIF (IP.EQ.3) THEN
          WRITE(IOUT,31) DID(I),(BUF(J,I),J=1,NTOT)
   31     FORMAT(1X,A,1X,1PG12.5,8(1X,G12.5):/(13X,9(1X,G12.5)))
C
C------------ FORMAT 8G13.6
        ELSEIF (IP.EQ.4) THEN
          WRITE(IOUT,41) DID(I),(BUF(J,I),J=1,NTOT)
   41     FORMAT(1X,A,1X,1PG13.6,7(1X,G13.6):/(13X,8(1X,G13.6)))
C
C------------ FORMAT 8G14.7
        ELSEIF (IP.EQ.5) THEN
          WRITE(IOUT,51) DID(I),(BUF(J,I),J=1,NTOT)
   51     FORMAT(1X,A,1X,1PG14.7,7(1X,G14.7):/(13X,8(1X,G14.7)))
C
C------------ FORMAT 6G10.3
        ELSEIF (IP.EQ.6) THEN 
          WRITE(IOUT,61) DID(I),(BUF(J,I),J=1,NTOT)
   61     FORMAT(1X,A,1X,1PG10.3,5(1X,G10.3):/(13X,6(1X,G10.3)))
C
C------------ FORMAT 5G11.4
        ELSEIF (IP.EQ.7) THEN
          WRITE(IOUT,71) DID(I),(BUF(J,I),J=1,NTOT)
   71     FORMAT(1X,A,1X,1PG11.4,4(1X,G11.4):/(13X,5(1X,G11.4)))
C
C------------ FORMAT 5G12.5
        ELSEIF (IP.EQ.8) THEN
          WRITE(IOUT,81) DID(I),(BUF(J,I),J=1,NTOT)
   81     FORMAT(1X,A,1X,1PG12.5,4(1X,G12.5):/(13X,5(1X,G12.5)))
C
C------------ FORMAT 4G13.6
        ELSEIF (IP.EQ.9) THEN
          WRITE(IOUT,91) DID(I),(BUF(J,I),J=1,NTOT)
   91     FORMAT(1X,A,1X,1PG13.6,3(1X,G13.6):/(13X,4(1X,G13.6)))
C
C------------ FORMAT 4G14.7
        ELSEIF (IP.EQ.10) THEN
          WRITE(IOUT,101) DID(I),(BUF(J,I),J=1,NTOT)
  101     FORMAT(1X,A,1X,1PG14.7,3(1X,G14.7):/(13X,4(1X,G14.7)))
C
        ENDIF
 1000 CONTINUE
C
C5------RETURN
      RETURN
      END
C **********************************************************************
      SUBROUTINE UCOLLBLR(NLBL1,NLBL2,NSPACE,NCPL,NDIG,IOUT,DID,NDTOT)
C
C-----VERSION 19980825 ERB
C     ******************************************************************
C     LABEL THE COLUMNS OF MATRIX PRINTOUT WITH OBSERVATION NAMES
C        NLBL1 IS THE START COLUMN (NUMBER)
C        NLBL2 IS THE STOP COLUMN (NUMBER)
C        NSPACE IS NUMBER OF BLANK SPACES TO LEAVE AT START OF LINE
C        NCPL IS NUMBER OF COLUMNS PER LINE
C        NDIG IS NUMBER OF CHARACTERS IN EACH COLUMN FIELD
C        IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*1 DOT, SPACE, BF*200
      CHARACTER*12 DID(NDTOT)
C
      DATA DOT,SPACE/'.',' '/
C     ------------------------------------------------------------------
C
C1------CALCULATE # OF COLUMNS TO BE PRINTED (NLBL), WIDTH
C1------OF A LINE (NTOT), NUMBER OF LINES (NWRAP).
      WRITE(IOUT,1)
    1 FORMAT(1X)
      NLBL = NLBL2-NLBL1+1
      N = NLBL
      IF(NLBL.GT.NCPL) N = NCPL
      LENPN = LEN(DID(1))
      MINCOLSP = LENPN+1
      IF (NDIG.LT.MINCOLSP) THEN
        WRITE(IOUT,200) NDIG,MINCOLSP
 200    FORMAT(' SPECIFIED FIELD WIDTH TOO SMALL FOR DID',
     &         '--STOP EXECUTION (UCOLLBL)',/
     &         ' NDIG = ',I2,'   MINCOLSP = ',I2)
        STOP
      ENDIF
      NTOT = NSPACE+LENPN+N*NDIG
      IND = (NDIG-LENPN-1)/2
      NWRAP = (NLBL-1)/NCPL+1
      J1 = NLBL1-NCPL
      J2 = NLBL1-1
C
C2------BUILD AND PRINT EACH LINE
      DO 40 N=1,NWRAP
C
C3------CLEAR THE BUFFER (BF).
        DO 20 I=1,130
          BF(I:I)=SPACE
   20   CONTINUE
        NBF = MINCOLSP+1+IND-NDIG
C
C4------DETERMINE FIRST (J1) AND LAST (J2) COLUMN # FOR THIS LINE.
        J1=J1+NCPL
        J2=J2+NCPL
        IF(J2.GT.NLBL2) J2=NLBL2
C5------LOAD THE COLUMN LABELS INTO THE BUFFER.
        DO 30 J=J1,J2
          NBF=NBF+NDIG
          NBF2 = NBF+LENPN-1
          BF(NBF:NBF2) = DID(J)
   30   CONTINUE
C
C6------PRINT THE CONTENTS OF THE BUFFER (I.E. PRINT THE LINE).
        WRITE(IOUT,31) BF(1:NBF2)
   31   FORMAT(1X,A)
C
   40 CONTINUE
C
C7------PRINT A LINE OF DOTS (FOR ESTHETIC PURPOSES ONLY).
   50 CONTINUE
      WRITE(IOUT,51) (DOT,I=1,NTOT)
   51 FORMAT(1X,200A1)
C
C8------RETURN
      RETURN
      END
C=======================================================================
      SUBROUTINE SVD (IA,A,BUFF1,BUFF3,IAAR)
C-----VERSION 20000615 MCH
C-----MODIFIED BY SC 26JUNE2003
C     CALCULATES THE SQUARE-ROOT OF A SQUARE MATRIX USING SVD (I.E. 
C     DECOMPOSE THE MATRIX INTO A MATRIX OF EIGENVECTORS AND A
C     DIAGONAL MATRIX OF CORRESPONDING EIGENVALUES).
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      REAL A
      INTEGER I, J, IA
      DOUBLE PRECISION BUFF1(IAAR,IAAR), BUFF3(IAAR)
      DIMENSION A(IAAR,IAAR)
C
      DO 30 I = 1,IA
        DO 20 J = 1, IA
          BUFF1(I,J) = A(I,J)
   20   CONTINUE
   30 CONTINUE
C     A is used as temporary storage of the off-diagonal elements of
C     the returned (by SSVD1) tridiagonal matrix used by
C     SSVD2
      CALL SSVD1(BUFF1,IA,IAAR,BUFF3,A)
      CALL SSVD2(BUFF3,A,IA,IAAR,BUFF1)
C     CALCULATE SQUARE-ROOT MATRIX
      DO 50 I = 1, IA
        BUFF3(I) = DSQRT(BUFF3(I))
   50 CONTINUE
      CALL SSVD3(IA,IAAR,BUFF1,BUFF3,A)
C      
      RETURN
      END
C=======================================================================
      SUBROUTINE SSVD1(A,N,NP,D,E)
C-----VERSION 1000 01FEB1992
C
C     ******************************************************************
C     COPYRIGHT (C) 1986 NUMERICAL RECIPES SOFTWARE, TRED2S,
C     REPRODUCED BY PERMISSION FROM THE BOOK NUMERICAL RECIPES: THE ART
C     OF SCIENTIFIC COMPUTING, PUBLISHED BY CAMBRIDGE UNIVERSITY PRESS
C     MODIFIED FOR DOUBLE PRECISION
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DOUBLE PRECISION A, D, F, G, H, HH, SCALE
      INTEGER I, J, K, L, N, NP
      DIMENSION A(NP,NP), D(NP), E(NP)
C     ------------------------------------------------------------------
      IF (N.GT.1) THEN
        DO 80 I = N, 2, -1
          L = I - 1
          H = 0.0
          SCALE = 0.0
          IF (L.GT.1) THEN
            DO 10 K = 1, L
              SCALE = SCALE + DABS(A(I,K))
   10       CONTINUE
            IF (SCALE.EQ.0.0) THEN
              E(I) = A(I,L)
            ELSE
              DO 20 K = 1, L
                A(I,K) = A(I,K)/SCALE
                H = H + A(I,K)**2
   20         CONTINUE
              F = A(I,L)
              G = -SIGN(DSQRT(H),F)
              E(I) = SCALE*G
              H = H - F*G
              A(I,L) = F - G
              F = 0.0
              DO 50 J = 1, L
                A(J,I) = A(I,J)/H
                G = 0.0
                DO 30 K = 1, J
                  G = G + A(J,K)*A(I,K)
   30           CONTINUE
                IF (L.GT.J) THEN
                  DO 40 K = J+1, L
                    G = G + A(K,J)*A(I,K)
   40             CONTINUE
                ENDIF
                E(J) = G/H
                F = F + E(J)*A(I,J)
   50         CONTINUE
              HH = F/(H+H)
              DO 70 J = 1, L
                F = A(I,J)
                G = E(J) - HH*F
                E(J) = G
                DO 60 K = 1, J
                  A(J,K) = A(J,K) - F*E(K) - G*A(I,K)
   60           CONTINUE
   70         CONTINUE
            ENDIF
          ELSE
            E(I) = A(I,L)
          ENDIF
          D(I) = H
   80   CONTINUE
      ENDIF
      D(1) = 0.0
      E(1) = 0.0
      DO 130 I = 1, N
        L = I - 1
        IF (D(I).NE.0.0) THEN
          DO 110 J = 1, L
            G = 0.0
            DO 90 K = 1, L
              G = G + A(I,K)*A(K,J)
   90       CONTINUE
            DO 100 K = 1, L
              A(K,J) = A(K,J) - G*A(K,I)
  100       CONTINUE
  110     CONTINUE
        ENDIF
        D(I) = A(I,I)
        A(I,I) = 1.0
        IF (L.GE.1) THEN
          DO 120 J = 1, L
            A(I,J) = 0.0
            A(J,I) = 0.0
  120     CONTINUE
        ENDIF
  130 CONTINUE
      RETURN
      END
C=======================================================================
      SUBROUTINE SSVD2(D,E,N,NP,Z)
C-----VERSION 1000 01FEB1992
C
C     ******************************************************************
C     COPYRIGHT (C) 1986 NUMERICAL RECIPES SOFTWARE, TQLIS,
C     REPRODUCED BY PERMISSION FROM THE BOOK NUMERICAL RECIPES: THE ART
C     OF SCIENTIFIC COMPUTING, PUBLISHED BY CAMBRIDGE UNIVERSITY PRESS
C     MODIFIED FOR DOUBLE PRECISION
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DOUBLE PRECISION B, C, D, DD, F, G, P, R, S, Z
      INTEGER I, ITER, K, L, M, N, NP
      CHARACTER*1 CHR
      DIMENSION D(NP), E(NP), Z(NP,NP)
C     ------------------------------------------------------------------
      IF (N.GT.1) THEN
        DO 10 I = 2, N
          E(I-1) = E(I)
   10   CONTINUE
        E(N) = 0.0
        DO 70 L = 1, N
          ITER = 0
   20     DO 30 M = L, N-1
            DD = DABS(D(M)) + DABS(D(M+1))
            IF (ABS(E(M))+DD.EQ.DD) GOTO 40
   30     CONTINUE
          M = N
   40     IF (M.NE.L) THEN
            IF (ITER.EQ.30) THEN
              WRITE (*,*) ' TOO MANY ITERATIONS'
              READ (*,'(A)') CHR
            ENDIF
            ITER = ITER + 1
            G = (D(L+1)-D(L))/(2.0*E(L))
            R = DSQRT(G**2+1.0)
            G = D(M) - D(L) + E(L)/(G+SIGN(R,G))
            S = 1.0
            C = 1.0
            P = 0.0
            DO 60 I = M-1, L, -1
              F = S*E(I)
              B = C*E(I)
              IF (DABS(F).GE.DABS(G)) THEN
                C = G/F
                R = DSQRT(C**2+1.0)
                E(I+1) = F*R
                S = 1.0/R
                C = C*S
              ELSE
                S = F/G
                R = DSQRT(S**2+1.0)
                E(I+1) = G*R
                C = 1.0/R
                S = S*C
              ENDIF
              G = D(I+1) - P
              R = (D(I)-G)*S + 2.0*C*B
              P = S*R
              D(I+1) = G + P
              G = C*R - B
              DO 50 K = 1, N
                F = Z(K,I+1)
                Z(K,I+1) = S*Z(K,I) + C*F
                Z(K,I) = C*Z(K,I) - S*F
   50         CONTINUE
   60       CONTINUE
            D(L) = D(L) - P
            E(L) = G
            E(M) = 0.0
            GOTO 20
          ENDIF
   70   CONTINUE
      ENDIF
      RETURN
      END
C=======================================================================
      SUBROUTINE SSVD3(N,NP,A,C,B)
C-----VERSION 19990504 ERB
C-----MODIFIED BY SC 26JUNE2003
C
C     ******************************************************************
C     CALCULATE MATRIX B = A * C * A(TRANSPOSE) WITH THE EIGEN-VECTORS
C     STORED IN A AND THE EIGENVALUES IN C
C=======================================================================
      REAL B, TMP
      INTEGER I, J, K, N
      DOUBLE PRECISION A(NP,NP), C(NP)
      DIMENSION B(NP,NP)
C=======================================================================
      DO 20 I = 1, N
        DO 10 J = 1, N
          B(I,J) = A(I,J)*C(J)
   10   CONTINUE
   20 CONTINUE
      DO 50 I = 1, N
        DO 40 J = I, N
          TMP = 0.0
          DO 30 K = 1, N
            TMP = TMP + B(J,K)*A(I,K)
   30     CONTINUE
          B(I,J) = TMP
   40   CONTINUE
   50 CONTINUE
      DO 70 I = 1, N
        DO 60 J = I + 1, N
          B(J,I) = B(I,J)
   60   CONTINUE
   70 CONTINUE
      RETURN
      END
C=======================================================================

